import re, os, xbmcgui, xbmcaddon, xbmc
import requests

addon = xbmcaddon.Addon(id='plugin.video.newtopialive')
home = addon.getAddonInfo('path').decode('utf-8')
image = xbmc.translatePath(os.path.join(home, 'icon.png'))

dialog = xbmcgui.Dialog()

auth_url = 'https://token.newtopia.de/api/2/GetLongLivedAuthToken/?callback=&authToken=&_='
stream_url = 'https://token.newtopia.de/api/2/GetToken/?callback=&authToken=%s&streamKey=stream_live_1&platform=web&_='

def select_quality(m3u8):
    try:
        save_selected = addon.getSetting('save_selected') == 'true'
        sel = []
        streams = []
        ret = None
        bandwidth = None
        resolution = None
        params = m3u8.split('?')[-1]
        content = requests.get(m3u8).content
        lines = content.splitlines()
        for line in lines:
            bandwidth = re.findall('bandwidth=(\d+)', line, re.IGNORECASE)
            if bandwidth: 
                bandwidth = bandwidth[0]
                try:
                    if int(bandwidth) > 1024: bandwidth = int(bandwidth)/1024
                except:
                    pass
            resolution = re.findall('resolution=(\d+x\d+)', line, re.IGNORECASE)
            if resolution: resolution = resolution[0]
            if resolution or bandwidth:
                name = 'Resolution: %s Bandwidth: %s kbps' % (resolution, bandwidth)
                sel.append(name)
            if line.startswith('http'):
                streams.append(line)
        if not save_selected:
            addon.setSetting(id='ret', value=None)
        else:
            try: ret = int(addon.getSetting('ret'))
            except: pass
        if ret != 0 and not ret: 
            ret = dialog.select('Select Quality', sel)
        if ret >= 0:
            if save_selected: addon.setSetting(id='ret', value=str(ret))
            m3u8 = streams[ret]
            if params and not '?' in m3u8: m3u8 = '%s?%s' % (m3u8, params)
            return m3u8
    except Exception as e:
        print '[plugin.video.newtopialive] error in select quality', e

try:
    json_data = requests.get(auth_url).json()
    auth_token = json_data['authToken']
    json_data = requests.get(stream_url % auth_token).json()
    m3u8 = json_data['url']
    if addon.getSetting('select') == 'true':
        m3u8 = select_quality(m3u8)
    if m3u8:
        item  = xbmcgui.ListItem('Newtopia', iconImage=image)
        xbmc.Player().play(m3u8, listitem=item)
except Exception as e:
    print '[plugin.video.newtopialive] error', e